unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Image1: TImage;
    TrackBar1: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  zeit, nr : Integer;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
VAR von, nach, leer, s, z, n : INTEGER;
    feld : ARRAY[1..3,0..10] of Integer;


  PROCEDURE zeichnen;
  VAR s, z : Integer;
  BEGIN
    image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
    for s:=1 TO 3 DO
    BEGIN
      image1.Canvas.Rectangle(200*s-3-50,30,200*s+3-50, 350);
      for z := 1 TO 10 DO
        if feld[s,z] > 0 THEN
          image1.Canvas.Rectangle(200*s-feld[s,z]*8-50,350-30*z,200*s+feld[s,z]*8-50, 350-30*z+20);
    END;
    sleep(zeit);
    Application.ProcessMessages;
  END;

  PROCEDURE hanoi(von, nach, leer, n : Integer);
  BEGIN
    if n > 1 THEN
      hanoi(von, leer, nach, n-1);
    INC(nr);
    Memo1.Lines.Add(IntToStr(nr)+'   '+IntToStr(von)+'  -->  '+IntToStr(nach));
    feld[nach,0] := feld[nach,0] + 1;
    feld[nach,feld[nach,0]] := feld[von,feld[von,0]];
    feld[von,feld[von,0]] := 0;
    feld[von,0] := feld[von,0] - 1;
    zeichnen;
    if n > 1 THEN
      hanoi(leer, nach, von, n-1);
  END;

begin
  n := StrToInt(edit1.text);
  for s:=1 TO 3 DO
    for z := 0 TO 10 DO
      feld[s,z] := 0;
  for z := 1 TO n DO
    feld[1,n+1-z] := z;
  feld[1,0] := n;

  von := 1;
  nach := 2;
  leer := 6-von-nach;
  memo1.Lines.Clear;
  nr := 0;
  hanoi(von, nach, leer,n);
  zeichnen;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  zeit := Trackbar1.Position * 200;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  zeit := 2000;
  TrackBar1.Position := 10;
end;

end.
